unit test;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    fen: TEdit;
    ButtonFen: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button3: TButton;
    Label3: TLabel;
    ListBox1: TListBox;
    Button4: TButton;
    procedure Button4Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ButtonFenClick(Sender: TObject);
  
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
 WP: array [0..5]  of  UInt64;
 BP: array [0..5]  of  UInt64;
 FName:string;
function searshMat2MoveFen(FenPos:string;Col,d:integer):string;stdcall;external 'Mat2Move.dll';
function  searshMat2MoveStr(sw,sb:string;Col:integer):string;stdcall;external 'Mat2Move.dll';
function  returnNewPosPiece(Color,i: Integer):UInt64;stdcall;external 'Mat2Move.dll';
function  setPosStrToU64(sw,sb:string):boolean;stdcall;external 'Mat2Move.dll';
function  setPosFenToU64(FenPos:string):boolean;stdcall;external 'Mat2Move.dll';
function  retutnVariant():string;stdcall;external 'Mat2Move.dll';
function U64ToStr(s:string;AP:array  of UInt64):string;stdcall;external 'Mat2Move.dll';
procedure NewPosView(WP,BP:array of  UInt64;col:integer);stdcall;external 'VisualBoard.dll';
function ViewBoard(WP,BP:array of  UInt64;col:integer):boolean;stdcall;external 'VisualBoard.dll';
function returnNumLeavesTree():integer;stdcall;external 'Mat2Move.dll';
function setPMove():boolean;stdcall;external 'MakeMove.dll';
procedure setStop();stdcall;external 'Mat2Move.dll';
implementation

{$R *.dfm}
function FenToVisual(sfen:String):String;
var
f:array [0..6] of Integer;
strN,strF,s01,svis:string;
i,j,k,num,n,p:Integer;
begin
with Form1.Label3 do begin
   Height:=180;
   Width:=180;
   Align := alBottom;
   Alignment := taCenter;
   AutoSize := False;
   Layout := tlCenter;
   WordWrap := True;
   Font.Name:= 'gc2004d';
   Font.Size:=14;
end;

f[1]:=48;
f[2]:=71;
f[3]:=87;
f[4]:=109;
f[5]:=169;
f[6]:=185;
f[0]:=163;
   strN:='12345678';
   strF:='KQRBNPkqrbnp';
   k:=length(sfen);
   n:=0;num:=0;p:=0;
   svis:='';
   for i := 1 to k do begin
     s01:=copy(sfen,i,1);
     if s01=' ' then  break;
     if s01='/' then begin
       if p<>8 then  begin
       Form1.Label3.Font.Name:='Arial';
       result:=' FEN ';
       exit;
       end;
     p:=0;
     svis:=svis+#13#10;
            case n of
               0:n:=1;
               1:n:=0;
             end;
     continue;
     end;
     num:=pos(s01,strN);
     if num>0 then begin
         for j := 1 to num do begin
         svis:=svis+chr(f[0]+n);
         p:=p+1;
            case n of
               0:n:=1;
               1:n:=0;
             end;
         end;
     end;
     num:=pos(s01,strF);
          if num>0 then begin
            p:=p+1;
            if num>6 then  begin
               svis:=svis+chr(f[num-6]+n+2);
            end else begin
               svis:=svis+chr(f[num]+n);
            end;
             case n of
               0:n:=1;
               1:n:=0;
             end;
         end;
   end;
 result:=svis;
end;
procedure TForm1.ButtonFenClick(Sender: TObject);
var
i:integer;
begin
setPMove();
 label1.Caption:='0';
 setPosFenToU64(test.Form1.fen.Text);
 for i := 0 to 5 do  begin
  WP[i]:=returnNewPosPiece(0,i);
  BP[i]:=returnNewPosPiece(1,i);
 end;
 NewPosView(WP,BP,0);
 button1.Enabled:=true;
 button2.Enabled:=true;
 button3.Enabled:=true;
end;
procedure TForm1.FormCreate(Sender: TObject);
var
s:string;
begin
  try
FName:=ExtractFilePath(Application.ExeName)+'fen.TXT';
 if FileExists(FName) then begin
   ListBox1.Items.LoadFromFile(FName);
   ListBox1.ItemIndex:=0;
 end else begin
 ShowMessage(' fen.txt  ');
 ListBox1.Items[0]:='rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w - - 0 1';
 end;
  finally
s:=ListBox1.Items[0];
test.Form1.fen.Text:=s;
Label3.Caption:=FenToVisual(s);
  end;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var
k:integer;
s:string;
begin
 button1.Enabled:=false;
 button2.Enabled:=false;
 button3.Enabled:=false;
 k:=ListBox1.ItemIndex;
 if k<0 then k:=0;
 s:=ListBox1.Items[k];
test.Form1.fen.Text:=s;
Label3.Caption:=FenToVisual(s);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
s1:string;
begin
 form1.ButtonFenClick(Sender);
 button1.Enabled:=false;
 button2.Enabled:=false;
 button3.Enabled:=false;
 s1:=searshMat2MoveFen(test.Form1.fen.Text,0,6);
 if s1='-' then NewPosView(WP,BP,0);
 //s2:=retutnVariant();
 ShowMessage(s1);
label1.Caption:=IntToStr(returnNumLeavesTree);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
s1:string;
begin
 form1.ButtonFenClick(Sender);
 button1.Enabled:=false;
 button2.Enabled:=false;
 button3.Enabled:=false;
 s1:=searshMat2MoveFen(test.Form1.fen.Text,0,4);
 if s1='-' then NewPosView(WP,BP,0);
 //s2:=retutnVariant();
 ShowMessage(s1);
label1.Caption:=IntToStr(returnNumLeavesTree);
end;
procedure TForm1.Button3Click(Sender: TObject);
var
s1:string;
begin
 form1.ButtonFenClick(Sender);
 button1.Enabled:=false;
 button2.Enabled:=false;
 button3.Enabled:=false; 
 s1:=searshMat2MoveFen(test.Form1.fen.Text,0,8);
 if s1='-' then NewPosView(WP,BP,0);
 //s2:=retutnVariant();
 ShowMessage(s1);
label1.Caption:=IntToStr(returnNumLeavesTree);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 setStop();
end;

end.
