unit unitBoard;// alexlaw@list.ru

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Menus;

type
  TBoardChess = class(TForm)
    Board: TImage;///  /
    Desk: TImage;//   
    Piece: TImage;//  
    SelectBox: TImage;
    Lamp: TImage;
    cheh: TImage;
    mat: TImage;
    MenuHiPawn: TPopupMenu;
    Qween: TMenuItem;
    Rook: TMenuItem;
    Bishop: TMenuItem;
    Knight: TMenuItem;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    procedure N3Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure KnightClick(Sender: TObject);
    procedure BishopClick(Sender: TObject);
    procedure RookClick(Sender: TObject);
    procedure QweenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BoardMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BoardClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;
//procedure RefreshDesk(WP,BP:array of  UInt64);
procedure init(color:integer);
var
  BoardChess: TBoardChess;

WPieceStart: array [0..5]  of  UInt64;// = (1152921504606846976,576460752303423488,9295429630892703744,2594073385365405696,4755801206503243776,71776119061217280);//(1152921504606846976,576460752303423488,9295429630892703744,2594073385365405696,4755801206503243776,71776119061217280);//  
BPieceStart: array [0..5]  of  UInt64;// = (16,8,129,36,66,65280);
WPiece: array [0..5]  of  UInt64;
BPiece: array [0..5]  of  UInt64;
NewVar:boolean;
FromTo,ToFrom,NumPoz,ColorMove,SelectFigure,clic,dmax: Integer;
depth:Integer=10;
SelectPawnHi:Integer=1;
Xmouse,Ymouse:Integer;
 MP:UInt64;
 BotW:Boolean=false;
 BotB:Boolean=false;//false;
 TinkSwch:Boolean=false; 
 MaskOneBit: array [0..63]  of  UInt64 = (
  1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768,65536,131072,262144,
  524288,1048576,2097152,4194304,8388608,16777216,33554432,67108864,134217728,
  268435456,536870912,1073741824,2147483648,4294967296,8589934592,17179869184,
  34359738368,68719476736,137438953472,274877906944,549755813888,1099511627776,
  2199023255552,4398046511104,8796093022208,17592186044416,35184372088832,
  70368744177664,140737488355328,281474976710656,562949953421312,1125899906842624,
  2251799813685248,4503599627370496,9007199254740992,18014398509481984,36028797018963968,
  72057594037927936,144115188075855872,288230376151711744,576460752303423488,
  1152921504606846976,2305843009213693952,4611686018427387904,9223372036854775808);
function  AllAttack(WP,BP: array of  UInt64;OB:UInt64;Color: Integer;UnMove:Boolean):UInt64;stdcall;external 'MoveGenerator.dll';
procedure MovePiceFromTo (WP,BP:array  of  UInt64;fromBox,ToBox:UInt64;col,NPawnHi: Integer;analiz:Boolean);stdcall;external 'MakeMove.dll';
function returnPlaceOnePiece(col,i:Integer):UInt64;stdcall;external 'MakeMove.dll';
function  returnMat():Integer;stdcall;external 'MoveGenerator.dll';
function  returnCheh(Color:Integer):Boolean;stdcall;external 'MoveGenerator.dll';
function  resetFlagKing00(i,j:Integer):Boolean; stdcall;external 'MoveGenerator.dll';
function searshMat2MoveU64(WP,BP: array of  UInt64;Col,d:integer):string;stdcall;external 'Mat2Move';
function undoOneMove():boolean;stdcall;external 'MakeMove.dll';
function returnStrMove():string;stdcall;external 'MakeMove.dll';
function setPMove():boolean;stdcall;external 'MakeMove.dll';
function Bolwan(WP,BP: array of  UInt64;Col,d:integer):string;stdcall;external 'Mat2Move.dll';
function returnFromTo():UInt64;stdcall;external 'Mat2Move.dll';
function returnToFrom():UInt64;stdcall;external 'Mat2Move.dll';
function returnPawnHi():Integer;stdcall;external 'Mat2Move.dll';
function U64tuNum(u:UInt64):Integer;stdcall;external 'Mat2Move.dll';
implementation

{$R *.dfm}
procedure changeMove ();
var m:integer;
begin
m:=returnMat();
      BoardChess.Cheh.Visible:=false;
      BoardChess.mat.Visible:=false;
 case ColorMove of
             0:begin
                BoardChess.Cheh.Visible:=returnCheh(1);
                ColorMove:=1;
                BoardChess.Lamp.Top:=0;
                BoardChess.cheh.Top:=0;
                BoardChess.mat.Top:=0;
               end;
              1:begin
                BoardChess.Cheh.Visible:=returnCheh(0);
                ColorMove:=0;
                BoardChess.Lamp.Top:=500;
                BoardChess.cheh.Top:=500;
                BoardChess.mat.Top:=500;
              end;
 end;
 case m of
      4,8:BoardChess.Cheh.Visible:=true;
      1,2:BoardChess.mat.Visible:=true;
      else begin
            BoardChess.mat.Visible:=false;
      end;
 end;
end;
procedure ClearDesk ();
var
bmp: tbitmap;
begin
try
 bmp := tbitmap.Create;
 bmp.Height:=480;
 bmp.Width:=480;
 bmp.Canvas.CopyRect(rect(0,0,480,480),BoardChess.Desk.Canvas,rect(0,0,480,480));
 BoardChess.Board.Canvas.CopyMode:=cmSrcCopy;
 BoardChess.Board.Canvas.Draw(24, 20, bmp);
finally
 bmp.free;
end;
end;
procedure DrawPiece(Poz,NumP,ColorP: Integer);
var
bmp: tbitmap;
a,b: Integer;
begin
try
 bmp := tbitmap.Create;
 bmp.Height:=60;
 bmp.Width:=60;
a:=Poz and 7;
b:=Poz shr 3;
bmp.Canvas.CopyRect(rect(0,0,60,60),BoardChess.Piece.Canvas,rect(60*NumP,60*ColorP,60*NumP+60,60*ColorP+60));
bmp.TransparentColor:=clYellow;
bmp.Transparent:=true;
BoardChess.Board.Canvas.Draw(24+60*a, 20+60*b, bmp);
finally
 bmp.free;
end;
end; 
procedure DrawPieceBoard(APiece:array of  UInt64;ColorPiece: Integer);
var
NumPiece: Integer;
i,j: Integer;
begin
NumPiece:=0;
                          while NumPiece<6 do begin
                                  for i:=63 downto 0 do  begin
                                  j := (APiece[NumPiece] shr i) and 1;
                                       case j  of
                                                 1:begin
                                                   DrawPiece(i,NumPiece,ColorPiece);
                                                  end;
                                       end;
                                   end;
                            NumPiece:=NumPiece+1;
                            end;

end;
procedure lightPiece (Poz: Integer);
var
a,b: Integer;
begin
 a:=Poz and 7;
 b:=Poz shr 3;
 BoardChess.SelectBox.Top:=20+60*b;
 BoardChess.SelectBox.Left:=24+60*a;
 BoardChess.SelectBox.Visible:=true;
end;
procedure DrawMoveBox(u:UInt64);
var
bmp: tbitmap;
a,b,i,j: Integer;
begin
try
 j:=0;
 bmp := tbitmap.Create;
 bmp.Height:=60;
 bmp.Width:=60;
bmp.TransparentColor:=clWhite;
bmp.Transparent:=true;
 bmp.Canvas.CopyRect(rect(0,0,60,60),BoardChess.Piece.Canvas,rect(360,0,420,60));
                                  for i:=63 downto 0 do  begin
                                  j := (u shr i) and 1;
                                       case j  of
                                                 1:begin
                                                  a:=i and 7;
                                                  b:=i shr 3;
                                                  BoardChess.Board.Canvas.Draw(24+60*a, 20+60*b, bmp);
                                                  end;
                                       end;
                                   end;
finally
  bmp.free;
end;
end;
procedure init(color:integer);
var
i:Integer;
begin
NewVar:=true;
BoardChess.N3.Checked:=false;
BotW:=false;
dmax:=depth;
//BoardChess.Board.ShowHint:=true;
 for i := 0 to 5 do begin
    WPiece[i]:=WPieceStart[i];
    BPiece[i]:=BPieceStart[i];
 end;
 case color of
     0:begin
  BoardChess.Lamp.Top:=500;
  BoardChess.Cheh.Top:=500;
  BoardChess.mat.Top:=500;
  clic:=0;
  ColorMove:=0;
     end;
     1:begin
  BoardChess.Lamp.Top:=0;
  BoardChess.Cheh.Top:=0;
  BoardChess.mat.Top:=0;
  clic:=1;
  ColorMove:=1;
     end;
 end;
  BoardChess.Cheh.Visible:=false;
  BoardChess.mat.Visible:=false;
  BoardChess.Lamp.Visible:=true;
  BoardChess.Board.Visible:=true;
FromTo:=0;
ToFrom:=0;
SelectFigure := -1;
SelectPawnHi:=1;
resetFlagKing00(0,2); resetFlagKing00(1,2); resetFlagKing00(2,2); resetFlagKing00(3,2);
setPMove();
end;
procedure RefreshDesk(WP,BP:array of  UInt64);stdcall;
begin
ClearDesk ();
DrawPieceBoard(WP,0);
DrawPieceBoard(BP,1);
BoardChess.Visible:=true;
BoardChess.Activate;
end;
procedure SelectPiece(APiece:array of  UInt64;num: Integer);
var
i,j: Integer;
begin
SelectFigure := -1;
RefreshDesk(WPiece,BPiece);

                 for i := 0 to 5 do  begin
                       if (MaskOneBit[num] and APiece[i])>0 then  begin
                   SelectFigure := i;
                   lightPiece(num);
                   MP:=AllAttack(WPiece,BPiece,MaskOneBit[num],ColorMove,false);
                   DrawMoveBox(MP); 
                       end;
                  end;

end;

procedure TBoardChess.BoardMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
Xmouse:=X+BoardChess.Left;Ymouse:=Y+BoardChess.Top;
NumPoz:= ((X-20) div 60)+8*((Y-24) div 60);
end;
procedure TBoardChess.FormCreate(Sender: TObject);
begin
 init(0);
end;
procedure TBoardChess.QweenClick(Sender: TObject);
begin
Qween.Checked:=true;
Rook.Checked:=false;
Bishop.Checked:=false;
Knight.Checked:=false;
end;
procedure TBoardChess.RookClick(Sender: TObject);
begin
Qween.Checked:=false;
Rook.Checked:=true;
Bishop.Checked:=false;
Knight.Checked:=false;
end;
procedure TBoardChess.BishopClick(Sender: TObject);
begin
Qween.Checked:=false;
Rook.Checked:=false;
Bishop.Checked:=true;
Knight.Checked:=false;
end;
procedure TBoardChess.KnightClick(Sender: TObject);
begin
Qween.Checked:=false;
Rook.Checked:=false;
Bishop.Checked:=false;
Knight.Checked:=true;
end;
procedure TBoardChess.N2Click(Sender: TObject);
var
b:boolean;
i:integer;
s:string;
begin
if NewVar then exit;
//s:=returnStrMove;
dmax:=dmax+1;
if dmax>depth then dmax:=depth;
b:=undoOneMove();
       for i := 0 to 5 do begin
        WPiece[i]:=returnPlaceOnePiece(0,i);
        BPiece[i]:=returnPlaceOnePiece(1,i);
        end;
RefreshDesk(WPiece,BPiece);
AllAttack(WPiece,BPiece,0,ColorMove,false);
//if s<>'' then changeMove ();
if not b then begin
changeMove ();
end else begin
BoardChess.N3.Checked:=false;
BotW:=false;
end;

end;

procedure BlackBolwan();//
var
i:integer;
s:string;
begin


end;
procedure WhiteBolwan();//
var
s:string;
i,sph:integer;
ft,tf:UInt64;
begin
clic:=0;
dmax:=dmax-2;
  s:=Bolwan(WPiece,BPiece,0,dmax);
  ft:=returnFromTo();
  //FromTo:=ft;
  tf:=returnToFrom();
  //ToFrom:=tf;
  sph:=returnPawnHi();
  NumPoz:=U64tuNum(ft);//FromTo
  //SelectPiece(WPiece,NumPoz);//SelectFigure
  if s<>'-' then begin
     AllAttack(WPiece,BPiece,WPiece[0],1,true);
     MovePiceFromTo(WPiece,BPiece,ft,tf,0,sph,false);
     NewVar:=false;
           for i := 0 to 5 do begin
        WPiece[i]:=returnPlaceOnePiece(0,i);
        BPiece[i]:=returnPlaceOnePiece(1,i);
           end;
  RefreshDesk(WPiece,BPiece);
  AllAttack(WPiece,BPiece,WPiece[0],1,false);
  changeMove ();
  end else begin

  end;
end;

procedure TBoardChess.N3Click(Sender: TObject);
var
i:integer;
begin
BoardChess.SelectBox.Visible:=false;
RefreshDesk(WPiece,BPiece);
if N3.Checked then begin
   BotW:=true;
   if ColorMove=0 then begin
       WhiteBolwan();
   end;
end else begin
   BotW:=false;
end;

end;
procedure TBoardChess.BoardClick(Sender: TObject);
var
i,j:Integer;
begin
if NumPoz>63 then exit;
if NumPoz<0 then exit;
if BotB then if ColorMove=1 then exit;//
if BotW then if ColorMove=0 then exit;
BoardChess.SelectBox.Visible:=false;
 if clic=1 then  begin
             ToFrom:=NumPoz;
             clic:=0;
 if (MP and MaskOneBit[ToFrom])=0  then  begin
     RefreshDesk(WPiece,BPiece);exit;
 end;
       case ColorMove  of
       0:begin
          if (WPiece[5] and MaskOneBit[FromTo] and 65280)>0 then  begin
           BoardChess.MenuHiPawn.Popup(Xmouse,Ymouse);
           BoardChess.MenuHiPawn.Popup(Xmouse,Ymouse);
         end;
       end;
       1:begin
         if (BPiece[5] and MaskOneBit[FromTo] and 71776119061217280)>0 then  begin
            BoardChess.MenuHiPawn.Popup(Xmouse,Ymouse);
            BoardChess.MenuHiPawn.Popup(Xmouse,Ymouse);
         end;
       end;
      end;
              if Qween.Checked then SelectPawnHi:=1;
              if Rook.Checked then SelectPawnHi:=2;
              if Bishop.Checked then SelectPawnHi:=3;
              if Knight.Checked then SelectPawnHi:=4;
  MovePiceFromTo(WPiece,BPiece,MaskOneBit[FromTo],MaskOneBit[ToFrom],ColorMove,SelectPawnHi,false);
  NewVar:=false;
 // BoardChess.Board.ShowHint:=false;
         for i := 0 to 5 do begin
        WPiece[i]:=returnPlaceOnePiece(0,i);
        BPiece[i]:=returnPlaceOnePiece(1,i);
        end;
 RefreshDesk(WPiece,BPiece);
  MP:=AllAttack(WPiece,BPiece,MaskOneBit[ToFrom],ColorMove,false);
 changeMove ();
 if BotB then BlackBolwan();//
 if BotW then WhiteBolwan(); 
             exit;
 end;//clic=1
 case ColorMove  of
       0:begin
          if not BotW then SelectPiece(WPiece,NumPoz);
        end;
       1:begin
         if not BotB then SelectPiece(BPiece,NumPoz);//
        end;
 end;
 if clic=0  then  begin
       if SelectFigure>=0 then  begin
            FromTo:=NumPoz;
            clic:=1;
       end;
 end;
end;
procedure NewPosView(WP,BP:array of  UInt64;col:integer);stdcall;
var
i:integer;
begin
   for i := 0 to 5 do begin
    WPieceStart[i]:=WP[i];
    BPieceStart[i]:=BP[i];
 end;
init(col);
RefreshDesk(WP,BP);
end;
procedure DrawLine(a,b:Integer;WP,BP:array of  UInt64);stdcall;
var
bmp: tbitmap;
begin
ClearDesk ();
DrawPieceBoard(WP,0);
DrawPieceBoard(BP,1);
try
 bmp := tbitmap.Create;
 bmp.Height:=506;
 bmp.Width:=501;
 bmp.Canvas.CopyRect(rect(0,0,506,501),BoardChess.Board.Canvas,rect(0,0,506,501));
 BoardChess.Board.Canvas.CopyMode:=cmSrcCopy;
 bmp.Canvas.Pen.Color:=clRed;
 bmp.Canvas.Pen.Width:=5;
 bmp.Canvas.Pen.Mode:=pmNop;
 bmp.Canvas.LineTo(56+60*(a and 7),51+60*(a shr 3));
 bmp.Canvas.Pen.Mode:=pmCopy;
 bmp.Canvas.LineTo(56+60*(b and 7),51+60*(b shr 3));
 BoardChess.Board.Canvas.Draw(0, 0, bmp);
finally
 bmp.free;
end;
end;
procedure setdepth(n:integer);stdcall;
begin
 depth:=n;
end;
exports DrawLine,NewPosView,RefreshDesk,setdepth;
end.
